package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.action;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.constant.SjjhConstant;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.VehicleViolationInfoService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh_interface.action.VehicleViolationInfoAction;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

@Slf4j
@RestController
public class VehicleViolationInfoActionImpl implements VehicleViolationInfoAction {
    private String xResponseCode = "x-responseCode";
    private String xIsCharge = "x-isCharge";
    @Autowired
    VehicleViolationInfoService service;
    @Override
    public ChannelTypeHandleResponseObject getVehicleViolationInfo(String channelId, int outTime, String customBody) {
        log.info("车辆违章信息查询--->channelId:{}--->outTime:{},--->customBody:{}",channelId,outTime,customBody);

        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes())
                .getRequest();

        //调用service
        ChannelTypeHandleResponseObject responseObject = service.getVehicleViolationInfo(request, customBody, outTime);

        //把接口参数、调用结果和是否收费放入访问日志中
        if(responseObject.getCode() != Constant.SUCCESS) {
            request.setAttribute(xResponseCode, Constant.CHANNEL_LOG_ERROR_CODE);
        } else {
            request.setAttribute(xResponseCode, Constant.CHANNEL_LOG_SUCCESS_CODE);
        }
        request.setAttribute(xIsCharge, responseObject.getIsCharge());

        try {
            request.setAttribute(Constant.CHANNEL_LOG_QUERY,
                    Base64.encodeBase64String(customBody.getBytes(SjjhConstant.UTF8_ENCODE)));
        } catch (Exception ex) {
            ErrorUtils.captureException(ex);
        }

        request.setAttribute(Constant.CHANNEL_TYPE_KEY,Constant.CHANNEL_TYPE_SYNC);
        return responseObject;
    }
}
