package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh_interface.vo.ResponseObject;

import javax.servlet.http.HttpServletRequest;

/**
 * @Auther jianggang
 * @Date 2018/10/25 15:55:19
 * @Description
 */
public interface YHChannelService {

    /**
     * 身份证二要素请求
     * @param channelId
     * @param outTime
     * @param customBody
     * @return
     * @throws Exception
     */
    ChannelTypeHandleResponseObject sendTwoParamIdCardRequest(
            String channelId, Integer outTime, String customBody);

	/**
	 * 全网位置校验
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	 ChannelTypeHandleResponseObject checkLocation(HttpServletRequest request, String customBody,
                                                   int outTime);


    /**
	 * 电信三要素检验接口
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	ChannelTypeHandleResponseObject yhDianXinCheck(HttpServletRequest request, String customBody, int outTime);


	/**
	 * 联通三要素检验接口
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	ChannelTypeHandleResponseObject yhLianTongCheck(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 联通在网时长接口
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	ChannelTypeHandleResponseObject yhLianTongOnlineTimeCheck(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 联通在网状态接口
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	ChannelTypeHandleResponseObject yhLianTongOnlineStatusCheck(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 移动在网状态查询
	 * @param outTime
	 * @param customBody
	 * @return
	 */
	ChannelTypeHandleResponseObject checkCMCCMobileOnlineStatus(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 移动在网时长查询
	 * @param outTime
	 * @param customBody
	 * @return
	 */
	ChannelTypeHandleResponseObject checkCMCCMobileOnlineTime(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 联通手机话费平均评分接口
	 * @param outTime
	 * @param customBody
	 * @return
	 */
	ChannelTypeHandleResponseObject lianTongCostScore(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 电信月消费金额接口
	 * @param outTime
	 * @param customBody
	 * @return
	 */
	ChannelTypeHandleResponseObject dianXinMonthCost(HttpServletRequest request, String customBody, int outTime);

	/**
	 * 移动手机消费区间查询接口
	 * @param outTime
	 * @param customBody
	 * @return
	 */
	ChannelTypeHandleResponseObject queryMobileConsumeSection(HttpServletRequest request, String customBody, int outTime);
}
