package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.utils;

import info.aspirecn.iov.sjjh.channel.inter.vo.platform.channel.po.Channels;
import info.aspirecn.iov.sjjh.service.sms.vo.RequestSmsNoTemplate;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.NotifySms;
import lombok.extern.slf4j.Slf4j;

import java.util.*;

@Slf4j
public class NotifyThread extends TimerTask{
    private NotifySms notifySms;
    public NotifyThread(NotifySms notifySms){
        this.notifySms=notifySms;
    }
    @Override
    public void run() {
        log.info("start,traceId:{}",notifySms);
        //根据channelId查询channel信息
        //根据类型下发指定内容的短信
        //如果存在问题，按1,2,4,8,16,32 来指定多少分钟后再次执行线程，如果达到量都之后
        try {
            List<Integer> ChannelIds = new ArrayList<>();
            ChannelIds.add(Integer.valueOf(notifySms.getChannId()));
            List<Channels> lists = notifySms.getChannelActionInterface().getChannelsById(ChannelIds);
            if(lists==null || lists.size()==0){
                return;
            }

            String channelName = lists.get(0).getChannelName();
            log.info("traceId:{},channelName:{}",notifySms.getTraceId(),channelName);
            String message = "";
            if (notifySms.getType() == 1) {//少于10000
                message = channelName + ",今日可用调用量已不足"+notifySms.getSupplierProperties().getNotityLimit()+"条，请关注";
            } else if (notifySms.getType() == 2) {//达到量
                message = channelName + ",今日可用调用量已用完，请关注";
            } else if (notifySms.getType() == 3) {//返回-53或者210
                message = channelName + ",因返回-53/210，今日不再请求该通道，请关注";
            }
            RequestSmsNoTemplate requestSmsNoTemplate = new RequestSmsNoTemplate();
            requestSmsNoTemplate.setTargetMobile(notifySms.getSupplierProperties().getTargetSms());
            requestSmsNoTemplate.setContent(message);
            log.info("traceId:{},smsTemplate:{}",notifySms.getTraceId(),requestSmsNoTemplate);
            notifySms.getSmsActionInterface().smsSendNoTemplate(requestSmsNoTemplate);
            log.info("end,notity:{}",notifySms);
        }catch (Exception ex){
            int count = notifySms.getCount();
            count++;
            Calendar calendar =Calendar.getInstance();
            int minute = calendar.get(Calendar.MINUTE);
            if(count>=5){
                return;
            }
            minute = 1<<count;
            notifySms.setCount(count);
            calendar.setTimeInMillis(calendar.getTimeInMillis()+(minute*60*1000));
            log.error("error message:{},{}",ex,notifySms.getTraceId());
            log.info("date:{},traceId:{}",calendar.getTime(),notifySms.getTraceId());
            Timer timer =new Timer();
            timer.schedule(new NotifyThread(notifySms),calendar.getTime());
        }
    }
}
